<?php if (!defined('DC_RC_PATH')) { return; }
# -- BEGIN LICENSE BLOCK ----------------------------------
# This file is part of dcNote, a plugin for Dotclear 2.
# 
# Copyright (c) 2012 Jean-Baptiste Langlois and contributors
# jeanbaptiste.langlois@gmail.com
# 
# Licensed under the GPL version 2.0 license.
# A copy of this license is available in LICENSE file or at
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# -- END LICENSE BLOCK ------------------------------------

$core->blog->settings->addNamespace('dcnote');

$core->addBehavior('publicHeadContent',array('dcnote','publicHeadContent'));	
$core->addBehavior('publicBeforeContentFilter',array('dcnote','publicBeforeContentFilter'));

class dcnote {
	
  public static function publicHeadContent($core) {

    $url = $core->blog->getQmarkURL().'pf='.basename(dirname(__FILE__));
    echo "<style type=\"text/css\">\n  @import url($url/style.css);\n</style>\n";

  }
	
  public static function publicBeforeContentFilter ($core, $tag, $arr) {

    if( $tag == 'EntryContent' || $tag == 'EntryExcerpt' ) {
		
      $txt = $arr[0];
      $out = "";

      $curpos = 0;

      while (true) {
        if (($npos = stripos($txt, "&lt;note", $curpos)) === false) {

          $out .= substr($txt, $curpos);
          break;

        } else {

          if (($ppos = stripos($txt, "<pre>", $curpos)) !== false) {

            if ($ppos < $npos) {

              $out .= substr($txt, $curpos, $ppos - $curpos);
              if (($pfpos = stripos($txt, "</pre>", $ppos)) !== false) {

                $out .= substr($txt, $ppos, $pfpos - $ppos + 6);

              }

              $curpos = $pfpos + 6;
              continue;

            }

          }

          if (($cpos = stripos($txt, "<code>", $curpos)) !== false) {

            if ($cpos < $npos) {

              $out .= substr($txt, $curpos, $cpos - $curpos);

              if (($cfpos = stripos($txt, "</code>", $cpos)) !== false) {

                $out .= substr($txt, $cpos, $cfpos - $cpos + 7);
              
              }

            $curpos = $cfpos+7;  
            continue;       

            }

          }

          $out .= substr($txt, $curpos, $npos - $curpos);
          if (($nfpos = stripos($txt, "&lt;/note&gt;", $npos)) !== false) {

            $notetxt = substr($txt, $npos, $nfpos - $npos + 13);

            if (preg_match('/&lt;note\s*(\w*)&gt;/is', $notetxt, $genre)) {
              switch(strtolower($genre[1])) {
                case 'important': $notecss='noteimportant'; break;
                case 'warning':   $notecss='notewarning'; break;       
                case 'tip':       $notecss='notetip'; break;    
                default:          $notecss='noteclassic';
              }

            } else {

              $notecss='noteclassic';

            }

            $noteout = "";

            if (preg_match('/&lt;note.*?&gt;(.*?)&lt;\/note&gt;/is', $notetxt, $noteinner)) {

              $noteout .= "<div class=\"dcnote $notecss\">\n";
              $noteout .= "<p>".$noteinner[1]."</p>\n";
              $noteout .= "</div>\n";

            }

            $out .= $noteout;

          }

          $curpos = $nfpos + 13;

        }

      }

      $arr[0] = $out;
			
    }

  }

}